import 'package:dio/dio.dart';
import 'package:morph_dart/src/models/auth/auth.dart';

class MeMethods {
  final Dio dio;

  const MeMethods(this.dio);

  Future<UserpoolUserResponse> signUp({
    required SignUpRequestBody body,
  }) async {
    final response = await dio
        .post<Map<String, dynamic>>(
          '/signup',
          data: body,
        )
        .then((res) => UserpoolUserResponse.fromJson(res.data!));

    return response;
  }

  Future<UserpoolUserResponse> getMe() async {
    final response = await dio
        .get<Map<String, dynamic>>('/me')
        .then((res) => UserpoolUserResponse.fromJson(res.data!));

    return response;
  }

  Future<UserpoolUserResponse> updateMe({
    required UpdateMeRequestBody body,
  }) async {
    final response = await dio
        .put<Map<String, dynamic>>(
          '/me',
          data: body,
        )
        .then((res) => UserpoolUserResponse.fromJson(res.data!));

    return response;
  }
}
