import 'package:json_annotation/json_annotation.dart';
import 'package:morph_dart/src/enums/field.dart';
import 'package:morph_dart/src/models/table/table.dart';

part 'field.g.dart';

///==================================================================
/// Request Body
///==================================================================
@JsonSerializable()
class CreateFieldRequestBody {
  final String field;
  final FieldCategory category;
  final int? length;
  final bool? isUnsigned;
  final String? linkedTableSlug;
  final bool? isNullable;
  final bool? isUnique;
  final FieldEntitySetting? setting;
  final String? comment;

  const CreateFieldRequestBody({
    required this.field,
    required this.category,
    this.length,
    this.isUnsigned,
    this.linkedTableSlug,
    this.isNullable,
    this.isUnique,
    this.setting,
    this.comment,
  });

  Map<String, dynamic> toJson() => _$CreateFieldRequestBodyToJson(this);
}

@JsonSerializable()
class UpdateFieldRequestBody {
  final String field;
  final int? length;
  final bool? isUnsigned;
  final String? linkedTableSlug;
  final bool? isNullable;
  final bool? isUnique;
  final FieldEntitySetting? setting;
  final String? comment;

  const UpdateFieldRequestBody({
    required this.field,
    this.length,
    this.isUnsigned,
    this.linkedTableSlug,
    this.isNullable,
    this.isUnique,
    this.setting,
    this.comment,
  });

  Map<String, dynamic> toJson() => _$UpdateFieldRequestBodyToJson(this);
}

@JsonSerializable()
class CreateFieldOptionRequestBody {
  final String value;

  const CreateFieldOptionRequestBody({required this.value});

  Map<String, dynamic> toJson() => _$CreateFieldOptionRequestBodyToJson(this);
}
